#include <stdio.h>
#include <Windows.h>
#include <string.h>
#include <stdlib.h>
#include <time.h>
#include <windowsx.h> 

//define for VerySetFunction
#define Very_Set_Range			131
#define Very_Get_PdfPageCount		206
#define Very_Get_PageBoxForStamp	260


typedef long	(__stdcall *veryReg)(char *reg);
typedef long	(__stdcall *veryOpen)(char *In,char *Out);
typedef void	(__stdcall *veryClose)(long id);
typedef long	(__stdcall *verySetFunction)(long id,long func_code,long para1,long para2,char *para3,char *para4);
typedef long	(__stdcall *veryGetFunction)(long id,long func_code,long para1,long para2,char *para3,char *para4);
typedef long	(__stdcall *veryAddImage)(  long id,long position, 
											char *filename,
											long shift_lr,long shift_tb,long rotate,long layer,
											long zoomW,long zoomH,
											long action,char *link,long pageno);
typedef long	(__stdcall *veryAddImageEx)(long id,long position, char *filename,
							long shift_lr,long shift_tb,long rotate,long layer,
							long width,long height,
							long action,char *link,long pageno);
typedef long	(__stdcall *veryAddText)(   long id,long position, 
											char *string,
											long color,long alignment,
											long shift_lr,long shift_tb,long rotate,long layer,
											long hollow,
											long fontcode,char *fontname,long fontsize,
											long action,char *link,long pageno);

typedef long	(__stdcall *veryAddLine)(	long id,long position, long width,long color,
											long shift_lr,long shift_tb,long rotate,long layer,
											long zoomW,long zoomH);
typedef long	(__stdcall *veryAddRect)(long id,long sx_,long sy_,long ex_,long ey_,
			   long side_width,long side_color,
			   long flagFill,long fill_color);

typedef long	(__stdcall *veryAddRectWithLayer)(long id,long sx_,long sy_,long ex_,long ey_,
			   long side_width,long side_color,
			   long flagFill,long fill_color,long layer);
typedef long	(__stdcall *veryStampUndo)(char *filename);
typedef long	(__stdcall *VeryStampAddLineEx)(long id,long sx,long sy,long ex,long ey,long width,long color);

HMODULE				g_hVeryW=NULL;

veryReg			pveryReg;
veryOpen		pveryOpen;
veryClose		pveryClose;
verySetFunction	pverySetFunction;
verySetFunction	pveryGetFunction;
veryAddImage	pveryAddImage;
veryAddImageEx	pveryAddImageEx;
veryAddText		pveryAddText;
veryAddLine		pveryAddLine;
veryAddRect		pveryAddRect;
veryAddRectWithLayer	pveryAddRectWithLayer;
veryStampUndo	pveryStampUndo;
VeryStampAddLineEx	pVeryStampAddLineEx;

void	GetModulePath(char *out_path,char *in_name);
BOOL	LoadVeryWDll(void);
void	FreeVeryWDll();


void GetModulePath(char *out_path,char *in_name)
{
	char *p;
	GetModuleFileName(NULL,out_path,256);
	p =strrchr(out_path,'\\');
	p[1]=0;
	strcat(out_path,in_name);
}
BOOL LoadVeryWDll_Older()
{
	char path[_MAX_PATH];
	GetModulePath(path,"PdfStamp.dll");
	g_hVeryW=LoadLibrary(path);
	if(g_hVeryW==NULL)
		goto Failer;

	pveryReg=(veryReg)GetProcAddress(g_hVeryW,"veryReg");
	if(pveryReg==NULL)
		goto Failer;
	pveryOpen=(veryOpen)GetProcAddress(g_hVeryW,"veryOpen");
	if(pveryOpen==NULL)
		goto Failer;
	pveryClose=(veryClose)GetProcAddress(g_hVeryW,"veryClose");
	if(pveryClose==NULL)
		goto Failer;
	pverySetFunction=(verySetFunction)GetProcAddress(g_hVeryW,"verySetFunction");
	if(pverySetFunction==NULL)
		goto Failer;
	pveryGetFunction=(veryGetFunction)GetProcAddress(g_hVeryW,"veryGetFunction");
	if(pveryGetFunction==NULL)
		goto Failer;
	pveryAddImage=(veryAddImage)GetProcAddress(g_hVeryW,"veryAddImage");
	if(pveryAddImage==NULL)
		goto Failer;
	pveryAddText=(veryAddText)GetProcAddress(g_hVeryW,"veryAddText");
	if(pveryAddText==NULL)
		goto Failer;
	pveryAddLine=(veryAddLine)GetProcAddress(g_hVeryW,"veryAddLine");
	if(pveryAddLine==NULL)
		goto Failer;
	pveryAddRect=(veryAddRect)GetProcAddress(g_hVeryW,"veryAddRect");
	if(pveryAddRect==NULL)
		goto Failer;
	pveryAddRectWithLayer=(veryAddRectWithLayer)GetProcAddress(g_hVeryW,"veryAddRectWithLayer");
	if(pveryAddRectWithLayer==NULL)
		goto Failer;
	pveryStampUndo=(veryStampUndo)GetProcAddress(g_hVeryW,"veryUndo");
	if(pveryStampUndo==NULL)
		goto Failer;

	return TRUE;
Failer:
	FreeVeryWDll(); 
	return FALSE;
}

BOOL LoadVeryWDll()
{
	char path[_MAX_PATH];
	GetModulePath(path,"verywrite.dll");
	g_hVeryW=LoadLibrary(path);
	if(g_hVeryW==NULL)
		goto Failer;

	pveryReg=(veryReg)GetProcAddress(g_hVeryW,"VeryStampReg");
	if(pveryReg==NULL)
		goto Failer;
	pveryOpen=(veryOpen)GetProcAddress(g_hVeryW,"VeryStampOpen");
	if(pveryOpen==NULL)
		goto Failer;
	pveryClose=(veryClose)GetProcAddress(g_hVeryW,"VeryStampClose");
	if(pveryClose==NULL)
		goto Failer;
	pverySetFunction=(verySetFunction)GetProcAddress(g_hVeryW,"VeryStampSetFunction");
	if(pverySetFunction==NULL)
		goto Failer;
	pveryGetFunction=(veryGetFunction)GetProcAddress(g_hVeryW,"VeryStampGetFunction");
	if(pveryGetFunction==NULL)
		goto Failer;
	pveryAddImage=(veryAddImage)GetProcAddress(g_hVeryW,"VeryStampAddImage");
	if(pveryAddImage==NULL)
		goto Failer;
	pveryAddImageEx=(veryAddImageEx)GetProcAddress(g_hVeryW,"VeryStampAddImageEx");
	if(pveryAddImageEx==NULL)
		goto Failer;
	pveryAddText=(veryAddText)GetProcAddress(g_hVeryW,"VeryStampAddText");
	if(pveryAddText==NULL)
		goto Failer;
	pveryAddLine=(veryAddLine)GetProcAddress(g_hVeryW,"VeryStampAddLine");
	if(pveryAddLine==NULL)
		goto Failer;
	pveryAddRect=(veryAddRect)GetProcAddress(g_hVeryW,"VeryStampAddRect");
	if(pveryAddRect==NULL)
		goto Failer;
	pveryAddRectWithLayer=(veryAddRectWithLayer)GetProcAddress(g_hVeryW,"VeryStampAddRectWithLayer");
	if(pveryAddRectWithLayer==NULL)
		goto Failer;
	pveryStampUndo=(veryStampUndo)GetProcAddress(g_hVeryW,"VeryStampUndo");
	if(pveryStampUndo==NULL)
		goto Failer;
	pVeryStampAddLineEx=(VeryStampAddLineEx)GetProcAddress(g_hVeryW,"VeryStampAddLineEx");
	if(pVeryStampAddLineEx==NULL)
		goto Failer;

	return TRUE;
Failer:
	FreeVeryWDll(); 
	return FALSE;
}

void FreeVeryWDll()
{
	if(g_hVeryW==NULL)
		return ;
	FreeLibrary(g_hVeryW);
	g_hVeryW=NULL;
}




void main(int argc,char* argv[])
{
	char szPDFFile[256];
	char szImageFile[256];
	long id;

	memset(szPDFFile,0,256);
	memset(szImageFile,0,256);

	if(!LoadVeryWDll())
	{
		if(!LoadVeryWDll_Older())
			return ;
	}


	GetModulePath(szPDFFile,"example.pdf");
		
	if(1)
	{
		//int pagecount = pveryGetFunction(id,206,0,0,0,0);
		//strcpy(szPDFFile,"C:\\temp\\pdfstamp_sdk_v1.1_full\\bin\\example.pdf");
		//strcpy(szImageFile,"C:\\_12_example.pdf");
		id=pveryOpen(szPDFFile,"_001.pdf");
		if(id>0)
		{
			int page = 1;
			int pagecount = pveryGetFunction(id, Very_Get_PdfPageCount, 0, 0, 0, 0);
			for(page = 1; page <= pagecount; page++)
			{
				char m_szStampBuf[1024];
				int left = pveryGetFunction(id, Very_Get_PageBoxForStamp, page, 0, "left", 0);
				int top = pveryGetFunction(id, Very_Get_PageBoxForStamp, page, 0, "top", 0);
				int pagewidth = pveryGetFunction(id, Very_Get_PageBoxForStamp, page, 0, "width", 0);
				int pageheight = pveryGetFunction(id, Very_Get_PageBoxForStamp, page, 0, "height", 0);

				pverySetFunction(id, Very_Set_Range, page, 1, 0, 0);
				sprintf(m_szStampBuf,"Page:<%d>, Page Box: [%d %d %d %d]",pagecount-page+1,left,top,pagewidth,pageheight);
				pveryAddText(id, 2, m_szStampBuf,255,0,0,0,0,0,0,300,0,10,1,"http://www.verypdf.com",0);
			}
			pverySetFunction(id, Very_Set_Range, 2, 2, 0,0);
			pveryAddImage(	id, 7, "logo.jpg",30,-30,0,0,0,0,0,0,0);
			pveryAddImage(	id, 3, "logo.jpg",-30,30,0,0,0,0,0,0,0);

			pveryAddImageEx(	id, 1, "logo.jpg",0,0,0,0,157*2,19*2,0,0,0);

			pveryAddRect(id, 100, 100, 150,150, 2, RGB(255,0,0),0,RGB(255,0,0));
			pveryAddRect(id, 100, 300, 150,350, 2, RGB(255,0,0),1,RGB(255,0,0));
			pveryAddRect(id, 100, 400, 150,450, 4, RGB(255,255,0),0,RGB(255,0,0));
			pveryAddRect(id, 100, 500, 150,550, 4, RGB(255,255,0),1,RGB(255,0,255));
			
			pveryAddLine(	id, 2, 1, RGB(255,0,0),
						0,80,0,0,
						80,0);
			pveryAddLine(	id, 6, 1, RGB(0,255,0),
						0,-80,0,0,
						80,0);
			pveryAddRectWithLayer(id, 200, 100, 250,150, 2, RGB(255,0,0),0,RGB(255,0,0),1);
			pveryAddRectWithLayer(id, 200, 300, 250,350, 2, RGB(255,0,0),1,RGB(255,0,0),1);
			pveryAddRectWithLayer(id, 200, 400, 250,450, 4, RGB(255,255,0),0,RGB(255,0,0),1);
			pveryAddRectWithLayer(id, 200, 500, 250,550, 4, RGB(255,255,0),1,RGB(255,0,255),1);

			pveryClose(id);
		}
		CopyFile("_001.pdf","_001_undo.pdf",FALSE);
		pveryStampUndo("_001_undo.pdf");
	}
	//%text stamp%
	//%page header and page footer%
	//%Stamps are placed in the duplicate file, leaving the original copy unchanged%
	id=pveryOpen(szPDFFile,"1.pdf");
	if(id>0){
		pveryAddText(	id, 7, 
						"\\d\\n\\t",
						255,0,
						50,-30,0,0,
						0,
						0,0,10,
						0,0,0);
		pveryAddText(	id, 5, 
						"Page \\P3+1 of \\c",
						255,0,
						-50,-30,0,0,
						0,
						0,0,10,
						0,0,0);
		pveryAddText(	id, 3, 
						"2003 verypdf.com Inc.",
						2666666,0,
						-30,30,	0,0,
						0,
						300,0,10,
						0,0,0);
		pveryClose(id);
	}

	//%.Supports Font Style, Font Size, Text Modes (solid, outline), Grayscale and RGB Color (0-255 RGB color values supported) %
	//%.Top, bottom, vertical center, diagonal-top left and diagonal-bottom left. %
	//%Supports multiple line text stamps within one stamp item %	
	id=pveryOpen(szPDFFile,"2.pdf");
	if(id>0){
		pveryAddText(	id, 3, 
						"Sample File\\nVerypdf",
						0,0,
						0,0,0,0,
						0,
						300,0,0,
						0,0,0);
		pveryAddText(	id, 6, 
						"Copyright verypdf.com, Inc.",
						RGB(255,200,100),0,
						0,0,0,0,
						0,
						0,0,0,
						0,0,0);
		pveryAddText(	id, 9, 
						"www.verypdf.com\\n Demo",
						255,0,
						0,0,-45,0,
						1,
						200,0,48,
						0,0,0);
		pveryClose(id);
	}

	//%.Grayscale Color (0-255 RGB color values supported) %
	//%.diagonal-top left and diagonal-bottom left. %
	//%Stamp on Top of or Underneath the original PDF document page contents %
	//Justification (when multi text)- Left, right, or center
	id=pveryOpen(szPDFFile,"3.pdf");
	if(id>0){
		pveryAddText(	id, 5, 
						"Page \\p of \\c",
						0,0,
						0,0,0,0,
						0,
						0,0,10,
						0,0,0);
		pveryAddText(	id, 9, 
						"www.verypdf.com\\n Demo",
						RGB(200,200,200),18,
						0,0,-45,1,
						0,
						301,0,48,
						0,0,0);
		pveryClose(id);
	}

	//%Supports Font Style, Font Size, Text Modes (solid, outline), Grayscale and RGB Color (0-255 RGB color values supported) %
	//%Stamp on Underneath the original PDF document page contents %
	//%Text and Image can be stamped on any angle. Any positive or negative numbers, including decimal numbers may be used to specify an angle in degrees %
	id=pveryOpen(szPDFFile,"4.pdf");
	if(id>0){
		pveryAddText(	id, 9, 
						"www.verypdf.com",
						RGB(200,200,200),0,
						0,0,-20,1,
						1,
						202,0,60,
						0,0,0);
		pveryClose(id);
	}

	//%Stamps can be placed in the exact vertical center of a page (or the exact vertical center within a individual stamping space) %
	id=pveryOpen(szPDFFile,"5.pdf");
	if(id>0){
		pveryAddText(	id, 9, 
						"www.verypdf.com",
						RGB(255,255,0),0,
						0,0,0,0,
						0,
						101,0,48,
						0,0,0);
		pveryAddText(	id, 8, 
						"www.verypdf.com",
						RGB(0,255,255),0,
						0,0,90,0,
						0,
						0,0,48,
						0,0,0);
		pveryAddText(	id, 4, 
						"www.verypdf.com",
						RGB(0,255,255),0,
						0,0,-90,0,
						0,
						0,0,48,
						0,0,0);
		pveryClose(id);
	}

	//tridimensional effect
	id=pveryOpen(szPDFFile,"6.pdf");
	if(id>0){
		pveryAddText(	id, 9, 
						"www.verypdf.com",
						RGB(64,64,64),0,
						1,1,45,0,
						0,
						0,0,64,
						0,0,0);
		pveryAddText(	id, 9, 
						"www.verypdf.com",
						RGB(255,0,0),0,
						0,0,45,0,
						0,
						0,0,64,
						0,0,0);
		pveryClose(id);
	}

	//hollow tridimensional effect
	id=pveryOpen(szPDFFile,"7.pdf");
	if(id>0){
		pveryAddText(	id, 9, 
						"www.verypdf.com",
						RGB(64,64,64),0,
						1,2,45,1,
						1,
						0,0,64,
						0,0,0);
		pveryAddText(	id, 9, 
						"www.verypdf.com",
						RGB(255,0,0),0,
						0,0,45,0,
						1,
						0,0,64,
						0,0,0);
		pveryClose(id);
	}

	//%Supports image stamp (JPEG/TIFF images) %
	id=pveryOpen(szPDFFile,"8.pdf");
	if(id>0){
		pveryAddImage(	id, 7, 
						"logo.jpg",
						30,-30,0,0,
						0,0,
						0,0,0);
		pveryAddImage(	id, 3, 
						"logo.jpg",
						-30,30,0,0,
						0,0,
						0,0,0);
		pveryClose(id);
	}

	//% image stamp  %
	//%vertical center.%
	id=pveryOpen(szPDFFile,"9.pdf");
	if(id>0){
		pveryAddImage(	id, 4, 
						"logo.jpg",
						-10,0,90,0,
						0,0,
						0,0,0);
		pveryAddImage(	id, 8, 
						"logo.jpg",
						10,0,-90,0,
						0,0,
						0,0,0);
		pveryClose(id);
	}

	//%	Wrap text to a new line if it would otherwise be too long to fit in its margined area%
	id=pveryOpen(szPDFFile,"10.pdf");
	if(id>0){
		pveryAddText(	id, 9, 
						"Wrap text to a new line if it would otherwise be too long to fit in its margined area.",
						2666666,16,
						0,0,0,1,
						0,
						0,0,64,
						0,0,0);
		pveryClose(id);
	}

	//%Supports web links%
	//%Enabling you to easily position the stamp in any location on the page %
	id=pveryOpen(szPDFFile,"11.pdf");
	if(id>0){
		pveryAddText(	id, 2, 
						"Supports web links",
						RGB(255,11,0),0,
						-50,200,0,1,
						0,
						0,0,48,
						1,"http://www.verypdf.com",0);
		pveryAddText(	id, 4, 
						"Enabling you to easily position the stamp\\n in any location on the page",
						RGB(255,11,22),17,
						-50,200,0,0,
						0,
						0,0,10,
						1,"http://www.verypdf.com",0);
		pveryClose(id);
	}

	//%text rotate and position%
	id=pveryOpen(szPDFFile,"12.pdf");
	if(id>0){
		pveryAddText(	id, 1, 
						"verypdf.com Inc.",
						65296,0,
						0,0,-45,0,
						0,
						0,0,48,
						0,0,0);
		pveryAddText(	id, 3, 
						"verypdf.com Inc.",
						65296,0,
						0,0,45,0,
						0,
						0,0,48,
						0,0,0);
		pveryAddText(	id, 5, 
						"verypdf.com Inc.",
						65296,0,
						0,0,-45,0,
						0,
						0,0,48,
						0,0,0);
		pveryAddText(	id, 7, 
						"verypdf.com Inc.",
						65296,0,
						0,0,45,0,
						0,
						0,0,48,
						0,0,0);

		pveryClose(id);
	}

	//%image rotate and position%
	id=pveryOpen(szPDFFile,"13.pdf");
	if(id>0){
		pveryAddImage(	id, 9, 
						"logo.jpg",
						-70,-70,-45,0,
						0,0,
						0,0,0);

		pveryAddImage(	id, 9, 
						"logo.jpg",
						70,-70,225,0,
						0,0,
						0,0,0);
		pveryAddImage(	id, 9, 
						"logo.jpg",
						70,70,135,0,
						0,0,
						0,0,0);
		pveryAddImage(	id, 9, 
						"logo.jpg",
						-70,70,45,0,
						0,0,
						0,0,0);

		pveryClose(id);
	}
	
	id=pveryOpen(szPDFFile,"14.pdf");
	if(id>0){
		pveryAddText(	id, 7, 
						"verypdf.com Inc.",
						165296,0,
						0,-100,-45,0,
						0,
						0,0,48,
						0,0,0);
		pveryAddText(	id, 7, 
						"verypdf.com Inc.",
						1652962,0,
						50,-200,-45,0,
						0,
						0,0,48,
						0,0,0);
		pveryAddText(	id, 7, 
						"verypdf.com Inc.",
						16529621,0,
						100,-300,-45,0,
						0,
						0,0,48,
						0,0,0);
		pveryAddText(	id, 7, 
						"verypdf.com Inc.",
						165296210,0,
						150,-400,-45,0,
						0,
						0,0,48,
						0,0,0);
		pveryAddText(	id, 7, 
						"verypdf.com Inc.",
						165210,0,
						200,-500,-45,0,
						0,
						0,0,48,
						0,0,0);

		pveryClose(id);
	}

	//%image zoom%
	id=pveryOpen(szPDFFile,"15.pdf");
	if(id>0){
		pveryAddImage(	id, 2, 
						"logo.jpg",
						80,200,-45,1,
						300,300,
						0,0,0);
		pveryClose(id);
	}


	//%Supports line stamp  %
	id=pveryOpen(szPDFFile,"16.pdf");
	if(id>0){
		pveryAddText(	id, 7, 
						"\\d\\n\\t",
						255,0,
						70,-50,0,0,
						0,
						0,0,10,
						0,0,0);
		pveryAddText(	id, 5, 
						"Page \\p of \\c ",
						255,0,
						-70,-50,0,0,
						0,
						0,0,10,
						0,0,0);
		pveryAddText(	id, 3, 
						"2003 verypdf.com Inc.",
						255,0,
						-60,60,0,0,
						0,
						300,0,10,
						0,0,0);

		pveryAddLine(	id, 2, 1, 0,
						0,80,0,0,
						80,0);
		pveryAddLine(	id, 6, 1, 0,
						0,-80,0,0,
						80,0);

		pveryClose(id);
	}

		

	//%Supports links (web links, page link, open file, remote page link).%
	id=pveryOpen(szPDFFile,"17.pdf");
	if(id>0){
		
		pveryAddText(	id, 2, 
						"Supports web links",
						255,0,
						-50,200,15,0,
						0,
						0,0,32,
						1,"http://www.verypdf.com",0);
		
		pveryAddText(	id, 4, 
						"Supports page links",
						255,0,
						-50,200,0,0,
						0,
						0,0,32,
						2,0,3);

		
		pveryAddImage(	id, 9, 
						"logo.jpg",
						0,0,15,1,
						0,0,
						3,"openlink.txt",0);
		
		pveryClose(id);
	}



	//%Set which pages to stamp on by selecting a predefined range.%
	//%	Every even page%
	id=pveryOpen(szPDFFile,"18.pdf");
	if(id>0){
		//%	Every even page%
		pverySetFunction(id, Very_Set_Range, -2, -2, 0,0);
 
		pveryAddText(	id, 2, 
						"Set which pages to stamp on by selecting a predefined range.",
						2666666,17,
						0,200,0,0,
						0,
						0,0,32,
						0,0,0);
		pveryAddRect(id, 100, 100, 150,150, 2, RGB(255,0,0),0,RGB(255,0,0));
		pveryAddRect(id, 100, 300, 150,350, 2, RGB(255,0,0),1,RGB(255,0,0));
		pveryAddRect(id, 100, 400, 150,450, 4, RGB(255,255,0),0,RGB(255,0,0));
		pveryAddRect(id, 100, 500, 150,550, 4, RGB(255,255,0),1,RGB(255,0,255));

		pveryClose(id);
	}
	FreeVeryWDll();
}