#include <windows.h>
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <time.h>
#include <windowsx.h> 
#include <math.h>

typedef void	(__stdcall *VerySetLicenseKeyFunc)(const char* lpszLicenseKey);
typedef BOOL (__stdcall *RotateImageFileFunc)(char *lpInImageFile, char *lpOutImageFile, int nDegree);

HMODULE					g_hVeryW = NULL;

VerySetLicenseKeyFunc	VerySetLicenseKey;
RotateImageFileFunc	RotateImageFile = NULL;

void	GetModulePath(char *out_path,char *in_name);
BOOL	LoadVeryWDll(void);
void	FreeVeryWDll();


void GetModulePath(char *out_path,char *in_name)
{
	char *p;
	GetModuleFileName(NULL,out_path,256);
	p =strrchr(out_path,'\\');
	p[1]=0;
	strcat(out_path,in_name);
}

BOOL LoadVeryWDll()
{
	char path[_MAX_PATH];
	GetModulePath(path,"verywrite.dll");
	g_hVeryW=LoadLibrary(path);
	if(g_hVeryW==NULL)
	{
		g_hVeryW=LoadLibrary("verywrite.dll");
		if(g_hVeryW==NULL)
			goto Failer;
	}


	VerySetLicenseKey = (VerySetLicenseKeyFunc)GetProcAddress(g_hVeryW,"VerySetLicenseKey");
	if(VerySetLicenseKey == NULL)
		goto Failer;
	RotateImageFile = (RotateImageFileFunc)GetProcAddress(g_hVeryW,"RotateImageFile");
	if(RotateImageFile == NULL)
		goto Failer;

	return TRUE;
Failer:
	FreeVeryWDll(); 
	return FALSE;

}

void FreeVeryWDll()
{
	if(g_hVeryW==NULL)
		return ;
	FreeLibrary(g_hVeryW);
	g_hVeryW=NULL;
}

void main()
{
	char szInImagePath[_MAX_PATH];
	char szOutImagePath[_MAX_PATH];
	long id;
	int	 iRet;

	if(!LoadVeryWDll())
		return;

	VerySetLicenseKey("XXXXXXXXXXXXXXXXXX");

	GetModulePath(szInImagePath, "test1.bmp");
	GetModulePath(szOutImagePath, "test1-rotated.bmp");

	RotateImageFile(szInImagePath, szOutImagePath, 45);
	
	FreeVeryWDll();
}